@echo off

title Subversion service manager
rem where svn root will be located
set svnroot=c:\svn




set quit=1

if "%1"=="install" goto install
if "%1"=="remove" goto remove
if "%1"=="start" goto start
if "%1"=="stop" goto stop

set quit=0

:loop
if "%quit%"=="1" exit 0

echo 	
echo 	
echo -----------------------------------------------
echo -       Subversion service manager            -
echo -----------------------------------------------
echo - 1  install svnserve.exe as windows service  -
echo - 2  remove svnserve.exe from windows service -
echo - 3  start the service                        -
echo - 4  stop the service                         -
echo - 5  locations helper                         -
echo - 0  exit                                     -
echo -----------------------------------------------
echo Current status:                             
sc query svnserve
echo -----------------------------------------------

set /P action=Enter your choise [1,2,3,4,5,0] :


if "%action%"=="1" goto install
if "%action%"=="2" goto remove
if "%action%"=="3" goto start
if "%action%"=="4" goto stop
if "%action%"=="5" goto helper
if "%action%"=="0" goto end

goto loop

:install

rem find full but short path of the svnserve.exe
for /F %%i in ("svnserve.exe") do set svnserve=%%~s$PATH:i
if "%svnserve%"=="" call :error "svnserve.exe not found in your PATH environment variable"

if exist "%svnroot%\repos" goto skipRoot
echo create root for svn repositories: 
echo    %svnroot%\repos
md "%svnroot%\repos"
:skipRoot

if not exist "%svnroot%\repos\test" goto skipTest1
set /P q=Do you want to recreate "test" repository ? [y,n] :
if not "%q%"=="y" goto skipTest1
if not "%q%"=="Y" goto skipTest1
rmdir /Q /S "%svnroot%\repos\test"
:skipTest1


if exist "%svnroot%\repos\test" goto skipTest2
echo create test repository: 
echo    svnadmin create "%svnroot%\repos\test"
svnadmin create "%svnroot%\repos\test"
:skipTest2

echo register service
sc create svnserve binpath= "%svnserve% --service --root %svnroot%" displayname= "Subversion" depend= tcpip start= auto
if errorlevel 1 call :error "can't register service"
goto start

:remove
sc delete svnserve
goto loop

:start
net start svnserve
if errorlevel 1 call :error "can't start service"
goto loop

:stop
sc stop svnserve
goto loop

:helper
echo -----------------------------------------------
echo use the following URL to access the repository:
echo svn://%COMPUTERNAME%/repos/XXX
echo where XXX is the name of your repository.
echo for example:
echo svn://%COMPUTERNAME%/repos/test
echo -----------------------------------------------
echo Your svn repositories root located here:
echo %svnroot%\repos
echo -----------------------------------------------
echo Repositories:
FOR /D %%i IN (c:\svn\repos\*.*) DO echo %%~nxi
echo -----------------------------------------------
echo To modify access rights for each repository
echo please refer to the following files in 
echo "conf" subfolder of each repository:
echo     svnserve.conf
echo     passwd

pause
goto loop



:error
echo Error: %~1
pause
exit 1


:end
